HDU-2795 Billboard

来源:互联网 发布:卓依婷 知乎 编辑:程序博客网 时间:2024/04/29 03:29

Billboard

Time Limit: 20000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)


Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
 

Input
There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
 

Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.
 

Sample Input
3 5 524333
 

Sample Output
1213-1
 ————————————————————集训23.1的分割线————————————————————
前言:好羞耻…………QAQ又开始抄袭胡大大的线段树了!
思路:可贴海报的行编号为1~h,则以1~h为区间,划分出一棵线段树,叶结点保存剩余可贴的长度,其余则保存该区间内所有行允许的最大长度。因为询问就是更新,所以不必update了,直接询问的时候push_up即可。
胡大大代码如下:
/*ID: j.sure.1PROG:LANG: C++*//****************************************/#include <cstdio>#include <cstdlib>#include <cstring>#include <algorithm>#include <cmath>#include <stack>#include <queue>#include <vector>#include <map>#include <string>#include <iostream>#define INF 0x3f3f3f3f#define LL long longusing namespace std;/****************************************/#define lson l, m, rt<<1#define rson m+1, r, rt<<1|1const int maxn = 2e5+5;int h, w, n;int tree[maxn<<2];//优先向上,则把h作为线段树区间,每次优先向左,就是优先放在h值小的位置///结点中保存行号为h的行能够容纳的w,区间中保存这几行能够容纳的最大w,这样就可以查找到这个可以放海报的位置void build(int l, int r, int rt){tree[rt] = w;if(l == r) return ;int m = (l+r) >> 1;build(lson); build(rson);}void push_up(int rt){tree[rt] = max(tree[rt<<1], tree[rt<<1|1]);}int query(int cur, int l, int r, int rt){if(l == r) {tree[rt] -= cur;//找到了确定的位置,贴上海报,更新return l;}int m = (l + r) >> 1;int ret;if(cur <= tree[rt<<1])ret = query(cur, lson);elseret = query(cur, rson);push_up(rt);//查询结束的时候 单点被更新,向上推return ret;}int main(){#ifdef J_Sure//freopen("000.in", "r", stdin);//freopen(".out", "w", stdout);#endifwhile(~scanf("%d%d%d", &h, &w, &n)) {if(h > n) h = n;//小剪枝build(1, h, 1);while(n--) {int cur;scanf("%d", &cur);if(tree[1] < cur) puts("-1");else printf("%d\n", query(cur, 1, h, 1));}}return 0;}


0 0